5824: Merge branch 'master' into 5824-keep-web-workbench
[arvados-dev.git] / jenkins / run-tests.sh
1 #!/bin/bash
2
3 . `dirname "$(readlink -f "$0")"`/libcloud-pin
4
5 read -rd "\000" helpmessage <<EOF
6 $(basename $0): Install and test Arvados components.
7
8 Exit non-zero if any tests fail.
9
10 Syntax:
11         $(basename $0) WORKSPACE=/path/to/arvados [options]
12
13 Options:
14
15 --skip FOO     Do not test the FOO component.
16 --only FOO     Do not test anything except the FOO component.
17 --temp DIR     Install components and dependencies under DIR instead of
18                making a new temporary directory. Implies --leave-temp.
19 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
20                Instead, show the path to give as --temp to reuse them in
21                subsequent invocations.
22 --skip-install Do not run any install steps. Just run tests.
23                You should provide GOPATH, GEMHOME, and VENVDIR options
24                from a previous invocation if you use this option.
25 --only-install Run specific install step
26 WORKSPACE=path Arvados source tree to test.
27 CONFIGSRC=path Dir with api server config files to copy into source tree.
28                (If none given, leave config files alone in source tree.)
29 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
30                Restrict apiserver tests to the given file
31 sdk/python_test="--test-suite test.test_keep_locator"
32                Restrict Python SDK tests to the given class
33 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
34                Restrict Workbench tests to the given file
35 services/arv-git-httpd_test="-check.vv"
36                Show all log messages, even when tests pass (also works
37                with services/keepstore_test etc.)
38 ARVADOS_DEBUG=1
39                Print more debug messages
40 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
41                *_test, and other examples shown above.
42
43 Assuming --skip-install is not given, all components are installed
44 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
45 test suites depend on other components being installed, and installing
46 everything tends to be quicker than debugging dependencies.
47
48 As a special concession to the current CI server config, CONFIGSRC
49 defaults to $HOME/arvados-api-server if that directory exists.
50
51 More information and background:
52
53 https://arvados.org/projects/arvados/wiki/Running_tests
54
55 Available tests:
56
57 apps/workbench
58 apps/workbench_benchmark
59 apps/workbench_profile
60 doc
61 services/api
62 services/arv-git-httpd
63 services/crunchstat
64 services/dockercleaner
65 services/fuse
66 services/keep-web
67 services/keepproxy
68 services/keepstore
69 services/login-sync
70 services/nodemanager
71 sdk/cli
72 sdk/pam
73 sdk/python
74 sdk/ruby
75 sdk/go/arvadosclient
76 sdk/go/keepclient
77 sdk/go/streamer
78 tools/keep-rsync
79
80 EOF
81
82 # First make sure to remove any ARVADOS_ variables from the calling
83 # environment that could interfere with the tests.
84 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
85
86 # Reset other variables that could affect our [tests'] behavior by
87 # accident.
88 GITDIR=
89 GOPATH=
90 VENVDIR=
91 VENV3DIR=
92 PYTHONPATH=
93 GEMHOME=
94 PERLINSTALLBASE=
95
96 COLUMNS=80
97
98 skip_install=
99 temp=
100 temp_preserve=
101
102 clear_temp() {
103     if [[ -z "$temp" ]]; then
104         # we didn't even get as far as making a temp dir
105         :
106     elif [[ -z "$temp_preserve" ]]; then
107         rm -rf "$temp"
108     else
109         echo "Leaving behind temp dirs in $temp"
110     fi
111 }
112
113 fatal() {
114     clear_temp
115     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
116     exit 1
117 }
118
119 report_outcomes() {
120     for x in "${successes[@]}"
121     do
122         echo "Pass: $x"
123     done
124
125     if [[ ${#failures[@]} == 0 ]]
126     then
127         echo "All test suites passed."
128     else
129         echo "Failures (${#failures[@]}):"
130         for x in "${failures[@]}"
131         do
132             echo "Fail: $x"
133         done
134     fi
135 }
136
137 exit_cleanly() {
138     trap - INT
139     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
140     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
141     stop_services
142     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
143     report_outcomes
144     clear_temp
145     exit ${#failures}
146 }
147
148 sanity_checks() {
149     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
150         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
151     echo Checking dependencies:
152     echo -n 'virtualenv: '
153     virtualenv --version \
154         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
155     echo -n 'go: '
156     go version \
157         || fatal "No go binary. See http://golang.org/doc/install"
158     echo -n 'gcc: '
159     gcc --version | egrep ^gcc \
160         || fatal "No gcc. Try: apt-get install build-essential"
161     echo -n 'fuse.h: '
162     find /usr/include -wholename '*fuse/fuse.h' \
163         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
164     echo -n 'pyconfig.h: '
165     find /usr/include -name pyconfig.h | egrep --max-count=1 . \
166         || fatal "No pyconfig.h. Try: apt-get install python-dev"
167     echo -n 'nginx: '
168     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
169         || fatal "No nginx. Try: apt-get install nginx"
170     echo -n 'perl: '
171     perl -v | grep version \
172         || fatal "No perl. Try: apt-get install perl"
173     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
174         echo -n "perl $mod: "
175         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
176             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
177     done
178     echo -n 'gitolite: '
179     which gitolite \
180         || fatal "No gitolite. Try: apt-get install gitolite3"
181 }
182
183 rotate_logfile() {
184   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
185   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
186   if [[ -f "$1/$2" ]]; then
187     THEDATE=`date +%Y%m%d%H%M%S`
188     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
189     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
190   fi
191 }
192
193 declare -a failures
194 declare -A skip
195 declare -A testargs
196 skip[apps/workbench_profile]=1
197
198 while [[ -n "$1" ]]
199 do
200     arg="$1"; shift
201     case "$arg" in
202         --help)
203             echo >&2 "$helpmessage"
204             echo >&2
205             exit 1
206             ;;
207         --skip)
208             skipwhat="$1"; shift
209             skip[$skipwhat]=1
210             ;;
211         --only)
212             only="$1"; skip[$1]=""; shift
213             ;;
214         --skip-install)
215             skip_install=1
216             ;;
217         --only-install)
218             skip_install=1
219             only_install="$1"; shift
220             ;;
221         --temp)
222             temp="$1"; shift
223             temp_preserve=1
224             ;;
225         --leave-temp)
226             temp_preserve=1
227             ;;
228         --retry)
229             retry=1
230             ;;
231         *_test=*)
232             suite="${arg%%_test=*}"
233             args="${arg#*=}"
234             testargs["$suite"]="$args"
235             ;;
236         *=*)
237             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
238             ;;
239         *)
240             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
241             exit 1
242             ;;
243     esac
244 done
245
246 start_api() {
247     echo 'Starting API server...'
248     cd "$WORKSPACE" \
249         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
250         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
251         && export ARVADOS_TEST_API_INSTALLED="$$" \
252         && (env | egrep ^ARVADOS)
253 }
254
255 start_nginx_proxy_services() {
256     echo 'Starting keepproxy, keep-web, arv-git-httpd, and nginx ssl proxy...'
257     cd "$WORKSPACE" \
258         && python sdk/python/tests/run_test_server.py start_keep_proxy \
259         && python sdk/python/tests/run_test_server.py start_keep-web \
260         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
261         && python sdk/python/tests/run_test_server.py start_nginx \
262         && export ARVADOS_TEST_PROXY_SERVICES=1
263 }
264
265 stop_services() {
266     if [[ -n "$ARVADOS_TEST_PROXY_SERVICES" ]]; then
267         unset ARVADOS_TEST_PROXY_SERVICES
268         cd "$WORKSPACE" \
269             && python sdk/python/tests/run_test_server.py stop_nginx \
270             && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
271             && python sdk/python/tests/run_test_server.py stop_keep-web \
272             && python sdk/python/tests/run_test_server.py stop_keep_proxy
273     fi
274     if [[ -n "$ARVADOS_TEST_API_HOST" ]]; then
275         unset ARVADOS_TEST_API_HOST
276         cd "$WORKSPACE" \
277             && python sdk/python/tests/run_test_server.py stop
278     fi
279 }
280
281 interrupt() {
282     failures+=("($(basename $0) interrupted)")
283     exit_cleanly
284 }
285 trap interrupt INT
286
287 sanity_checks
288
289 echo "WORKSPACE=$WORKSPACE"
290
291 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
292     # Jenkins expects us to use this by default.
293     CONFIGSRC="$HOME/arvados-api-server"
294 fi
295
296 # Clean up .pyc files that may exist in the workspace
297 cd "$WORKSPACE"
298 find -name '*.pyc' -delete
299
300 if [[ -z "$temp" ]]; then
301     temp="$(mktemp -d)"
302 fi
303
304 # Set up temporary install dirs (unless existing dirs were supplied)
305 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE
306 do
307     if [[ -z "${!tmpdir}" ]]; then
308         eval "$tmpdir"="$temp/$tmpdir"
309     fi
310     if ! [[ -d "${!tmpdir}" ]]; then
311         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
312     fi
313 done
314
315 setup_ruby_environment() {
316     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
317       source "$HOME/.rvm/scripts/rvm"
318       using_rvm=true
319     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
320       source "/usr/local/rvm/scripts/rvm"
321       using_rvm=true
322     else
323       using_rvm=false
324     fi
325
326     if [[ "$using_rvm" == true ]]; then
327         # If rvm is in use, we can't just put separate "dependencies"
328         # and "gems-under-test" paths to GEM_PATH: passenger resets
329         # the environment to the "current gemset", which would lose
330         # our GEM_PATH and prevent our test suites from running ruby
331         # programs (for example, the Workbench test suite could not
332         # boot an API server or run arv). Instead, we have to make an
333         # rvm gemset and use it for everything.
334
335         [[ `type rvm | head -n1` == "rvm is a function" ]] \
336             || fatal 'rvm check'
337
338         # Put rvm's favorite path back in first place (overriding
339         # virtualenv, which just put itself there). Ignore rvm's
340         # complaint about not being in first place already.
341         rvm use @default 2>/dev/null
342
343         # Create (if needed) and switch to an @arvados-tests
344         # gemset. (Leave the choice of ruby to the caller.)
345         rvm use @arvados-tests --create \
346             || fatal 'rvm gemset setup'
347
348         rvm env
349     else
350         # When our "bundle install"s need to install new gems to
351         # satisfy dependencies, we want them to go where "gem install
352         # --user-install" would put them. (However, if the caller has
353         # already set GEM_HOME, we assume that's where dependencies
354         # should be installed, and we should leave it alone.)
355
356         if [ -z "$GEM_HOME" ]; then
357             user_gempath="$(gem env gempath)"
358             export GEM_HOME="${user_gempath%%:*}"
359         fi
360         PATH="$(gem env gemdir)/bin:$PATH"
361
362         # When we build and install our own gems, we install them in our
363         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
364         # PATH so integration tests prefer them over other versions that
365         # happen to be installed in $user_gempath, system dirs, etc.
366
367         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
368         PATH="$tmpdir_gem_home/bin:$PATH"
369         export GEM_PATH="$tmpdir_gem_home:$(gem env gempath)"
370
371         echo "Will install dependencies to $(gem env gemdir)"
372         echo "Will install arvados gems to $tmpdir_gem_home"
373         echo "Gem search path is GEM_PATH=$GEM_PATH"
374     fi
375 }
376
377 with_test_gemset() {
378     if [[ "$using_rvm" == true ]]; then
379         "$@"
380     else
381         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
382     fi
383 }
384
385 gem_uninstall_if_exists() {
386     if gem list "$1\$" | egrep '^\w'; then
387         gem uninstall --force --all --executables "$1"
388     fi
389 }
390
391 setup_virtualenv() {
392     local venvdest=$1; shift
393     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
394         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
395     fi
396     "$venvdest/bin/pip" install 'setuptools>=18' 'pip>=7'
397     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
398     "$venvdest/bin/pip" install 'mock>=1.0'
399 }
400
401 export PERLINSTALLBASE
402 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
403
404 export GOPATH
405 mkdir -p "$GOPATH/src/git.curoverse.com"
406 ln -sfn "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
407     || fatal "symlink failed"
408
409 setup_virtualenv "$VENVDIR" --python python2.7
410 . "$VENVDIR/bin/activate"
411
412 # Needed for run_test_server.py which is used by certain (non-Python) tests.
413 pip freeze 2>/dev/null | egrep ^PyYAML= \
414     || pip install PyYAML >/dev/null \
415     || fatal "pip install PyYAML failed"
416
417 # Preinstall forked version of libcloud, because nodemanager "pip install"
418 # won't pick it up by default.
419 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
420     || pip install --pre --ignore-installed https://github.com/curoverse/libcloud/archive/apache-libcloud-$LIBCLOUD_PIN.zip >/dev/null \
421     || fatal "pip install apache-libcloud failed"
422
423 # Deactivate Python 2 virtualenv
424 deactivate
425
426 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
427 # Otherwise, skip dependent tests.
428 PYTHON3=$(which python3)
429 if [ "0" = "$?" ]; then
430     setup_virtualenv "$VENV3DIR" --python python3
431 else
432     PYTHON3=
433     skip[services/dockercleaner]=1
434     cat >&2 <<EOF
435
436 Warning: python3 could not be found
437 services/dockercleaner install and tests will be skipped
438
439 EOF
440 fi
441
442 # Reactivate Python 2 virtualenv
443 . "$VENVDIR/bin/activate"
444
445 # Note: this must be the last time we change PATH, otherwise rvm will
446 # whine a lot.
447 setup_ruby_environment
448
449 echo "PATH is $PATH"
450
451 if ! which bundler >/dev/null
452 then
453     gem install --user-install bundler || fatal 'Could not install bundler'
454 fi
455
456 checkexit() {
457     if [[ "$1" != "0" ]]; then
458         title "!!!!!! $2 FAILED !!!!!!"
459         failures+=("$2 (`timer`)")
460     else
461         successes+=("$2 (`timer`)")
462     fi
463 }
464
465 timer_reset() {
466     t0=$SECONDS
467 }
468
469 timer() {
470     echo -n "$(($SECONDS - $t0))s"
471 }
472
473 do_test() {
474     while ! do_test_once ${@} && [[ "$retry" == 1 ]]
475     do
476         read -p 'Try again? [Y/n] ' x
477         if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
478         then
479             break
480         fi
481     done
482 }
483
484 do_test_once() {
485     unset result
486     if [[ -z "${skip[$1]}" ]] && ( [[ -z "$only" ]] || [[ "$only" == "$1" ]] )
487     then
488         title "Running $1 tests"
489         timer_reset
490         if [[ "$2" == "go" ]]
491         then
492             covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
493             coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
494             # We do "go get -t" here to catch compilation errors
495             # before trying "go test". Otherwise, coverage-reporting
496             # mode makes Go show the wrong line numbers when reporting
497             # compilation errors.
498             if [[ -n "${testargs[$1]}" ]]
499             then
500                 # "go test -check.vv giturl" doesn't work, but this
501                 # does:
502                 cd "$WORKSPACE/$1" && \
503                     go get -t "git.curoverse.com/arvados.git/$1" && \
504                     go test ${coverflags[@]} ${testargs[$1]}
505             else
506                 # The above form gets verbose even when testargs is
507                 # empty, so use this form in such cases:
508                 go get -t "git.curoverse.com/arvados.git/$1" && \
509                     go test ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
510             fi
511             result="$?"
512             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
513             rm "$WORKSPACE/tmp/.$covername.tmp"
514         elif [[ "$2" == "pip" ]]
515         then
516             # $3 can name a path directory for us to use, including trailing
517             # slash; e.g., the bin/ subdirectory of a virtualenv.
518             cd "$WORKSPACE/$1" \
519                 && "${3}python" setup.py test ${testargs[$1]}
520         elif [[ "$2" != "" ]]
521         then
522             "test_$2"
523         else
524             "test_$1"
525         fi
526         result=${result:-$?}
527         checkexit $result "$1 tests"
528         title "End of $1 tests (`timer`)"
529         return $result
530     else
531         title "Skipping $1 tests"
532     fi
533 }
534
535 do_install() {
536     if [[ -z "$skip_install" || (-n "$only_install" && "$only_install" == "$1") ]]
537     then
538         title "Running $1 install"
539         timer_reset
540         if [[ "$2" == "go" ]]
541         then
542             go get -t "git.curoverse.com/arvados.git/$1"
543         elif [[ "$2" == "pip" ]]
544         then
545             # $3 can name a path directory for us to use, including trailing
546             # slash; e.g., the bin/ subdirectory of a virtualenv.
547
548             # Need to change to a different directory after creating
549             # the source dist package to avoid a pip bug.
550             # see https://arvados.org/issues/5766 for details.
551
552             # Also need to install twice, because if it believes the package is
553             # already installed, pip it won't install it.  So the first "pip
554             # install" ensures that the dependencies are met, the second "pip
555             # install" ensures that we've actually installed the local package
556             # we just built.
557             cd "$WORKSPACE/$1" \
558                 && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
559                 && cd "$WORKSPACE" \
560                 && "${3}pip" install --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
561                 && "${3}pip" install --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
562         elif [[ "$2" != "" ]]
563         then
564             "install_$2"
565         else
566             "install_$1"
567         fi
568         checkexit $? "$1 install"
569         title "End of $1 install (`timer`)"
570     else
571         title "Skipping $1 install"
572     fi
573 }
574
575 title () {
576     txt="********** $1 **********"
577     printf "\n%*s%s\n\n" $((($COLUMNS-${#txt})/2)) "" "$txt"
578 }
579
580 bundle_install_trylocal() {
581     (
582         set -e
583         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
584         if ! bundle install --local --no-deployment; then
585             echo "(Running bundle install again, without --local.)"
586             bundle install --no-deployment
587         fi
588         bundle package --all
589     )
590 }
591
592 install_doc() {
593     cd "$WORKSPACE/doc" \
594         && bundle_install_trylocal \
595         && rm -rf .site
596 }
597 do_install doc
598
599 install_gem() {
600     gemname=$1
601     srcpath=$2
602     with_test_gemset gem_uninstall_if_exists "$gemname" \
603         && cd "$WORKSPACE/$srcpath" \
604         && bundle_install_trylocal \
605         && gem build "$gemname.gemspec" \
606         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
607 }
608
609 install_ruby_sdk() {
610     install_gem arvados sdk/ruby
611 }
612 do_install sdk/ruby ruby_sdk
613
614 install_perl_sdk() {
615     cd "$WORKSPACE/sdk/perl" \
616         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
617         && make install INSTALLDIRS=perl
618 }
619 do_install sdk/perl perl_sdk
620
621 install_cli() {
622     install_gem arvados-cli sdk/cli
623 }
624 do_install sdk/cli cli
625
626 install_login-sync() {
627     install_gem arvados-login-sync services/login-sync
628 }
629 do_install services/login-sync login-sync
630
631 # Install the Python SDK early. Various other test suites (like
632 # keepproxy) bring up run_test_server.py, which imports the arvados
633 # module. We can't actually *test* the Python SDK yet though, because
634 # its own test suite brings up some of those other programs (like
635 # keepproxy).
636 declare -a pythonstuff
637 pythonstuff=(
638     sdk/pam
639     sdk/python
640     services/fuse
641     services/nodemanager
642     )
643 for p in "${pythonstuff[@]}"
644 do
645     do_install "$p" pip
646 done
647 if [ -n "$PYTHON3" ]; then
648     do_install services/dockercleaner pip "$VENV3DIR/bin/"
649 fi
650
651 install_apiserver() {
652     cd "$WORKSPACE/services/api" \
653         && RAILS_ENV=test bundle_install_trylocal
654
655     rm -f config/environments/test.rb
656     cp config/environments/test.rb.example config/environments/test.rb
657
658     if [ -n "$CONFIGSRC" ]
659     then
660         for f in database.yml application.yml
661         do
662             cp "$CONFIGSRC/$f" config/ || fatal "$f"
663         done
664     fi
665
666     # Fill in a random secret_token and blob_signing_key for testing
667     SECRET_TOKEN=`echo 'puts rand(2**512).to_s(36)' |ruby`
668     BLOB_SIGNING_KEY=`echo 'puts rand(2**512).to_s(36)' |ruby`
669
670     sed -i'' -e "s:SECRET_TOKEN:$SECRET_TOKEN:" config/application.yml
671     sed -i'' -e "s:BLOB_SIGNING_KEY:$BLOB_SIGNING_KEY:" config/application.yml
672
673     # Set up empty git repo (for git tests)
674     GITDIR=$(mktemp -d)
675     sed -i'' -e "s:/var/cache/git:$GITDIR:" config/application.default.yml
676
677     rm -rf $GITDIR
678     mkdir -p $GITDIR/test
679     cd $GITDIR/test \
680         && git init \
681         && git config user.email "jenkins@ci.curoverse.com" \
682         && git config user.name "Jenkins, CI" \
683         && touch tmp \
684         && git add tmp \
685         && git commit -m 'initial commit'
686
687     # Clear out any lingering postgresql connections to the test
688     # database, so that we can drop it. This assumes the current user
689     # is a postgresql superuser.
690     cd "$WORKSPACE/services/api" \
691         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
692         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
693
694     cd "$WORKSPACE/services/api" \
695         && RAILS_ENV=test bundle exec rake db:drop \
696         && RAILS_ENV=test bundle exec rake db:setup \
697         && RAILS_ENV=test bundle exec rake db:fixtures:load
698 }
699 do_install services/api apiserver
700
701 declare -a gostuff
702 gostuff=(
703     sdk/go/arvadosclient
704     sdk/go/streamer
705     services/arv-git-httpd
706     services/crunchstat
707     services/keep-web
708     services/keepstore
709     sdk/go/keepclient
710     services/keepproxy
711     services/datamanager/summary
712     services/datamanager/collection
713     services/datamanager
714     tools/keep-rsync
715     )
716 for g in "${gostuff[@]}"
717 do
718     do_install "$g" go
719 done
720
721 install_workbench() {
722     cd "$WORKSPACE/apps/workbench" \
723         && mkdir -p tmp/cache \
724         && RAILS_ENV=test bundle_install_trylocal
725 }
726 do_install apps/workbench workbench
727
728 test_doclinkchecker() {
729     (
730         set -e
731         cd "$WORKSPACE/doc"
732         ARVADOS_API_HOST=qr1hi.arvadosapi.com
733         # Make sure python-epydoc is installed or the next line won't
734         # do much good!
735         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
736     )
737 }
738 do_test doc doclinkchecker
739
740 stop_services
741
742 test_apiserver() {
743     cd "$WORKSPACE/services/api" \
744         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
745 }
746 do_test services/api apiserver
747
748 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
749 # because we don't need to start up the api server for subsequent tests.
750 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
751   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
752   exit_cleanly
753 fi
754
755 start_api
756
757 test_ruby_sdk() {
758     cd "$WORKSPACE/sdk/ruby" \
759         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
760 }
761 do_test sdk/ruby ruby_sdk
762
763 test_cli() {
764     cd "$WORKSPACE/sdk/cli" \
765         && mkdir -p /tmp/keep \
766         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
767 }
768 do_test sdk/cli cli
769
770 test_login-sync() {
771     cd "$WORKSPACE/services/login-sync" \
772         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
773 }
774 do_test services/login-sync login-sync
775
776 for p in "${pythonstuff[@]}"
777 do
778     do_test "$p" pip
779 done
780 do_test services/dockercleaner pip "$VENV3DIR/bin/"
781
782 for g in "${gostuff[@]}"
783 do
784     do_test "$g" go
785 done
786
787 test_workbench() {
788     start_nginx_proxy_services \
789         && cd "$WORKSPACE/apps/workbench" \
790         && RAILS_ENV=test bundle exec rake test TESTOPTS=-v ${testargs[apps/workbench]}
791 }
792 do_test apps/workbench workbench
793
794 test_workbench_benchmark() {
795     start_nginx_proxy_services \
796         && cd "$WORKSPACE/apps/workbench" \
797         && RAILS_ENV=test bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
798 }
799 do_test apps/workbench_benchmark workbench_benchmark
800
801 test_workbench_profile() {
802     start_nginx_proxy_services \
803         && cd "$WORKSPACE/apps/workbench" \
804         && RAILS_ENV=test bundle exec rake test:profile ${testargs[apps/workbench_profile]}
805 }
806 do_test apps/workbench_profile workbench_profile
807
808 exit_cleanly